<template>
	<div :class="[$style.productPrice, { [$style.bottomOutside]: bottomOutside }]">
		<div
			:class="[
				$style[`row${appearance}`],
				{
					[$style[`${affirmTextColor}AffirmTextColor`]]: affirmTextColor,
					[$style.hasListPrice]: listPriceString,
					[$style.hasAffirm]: affirm,
				},
			]"
		>
			<div :class="$style.contentWrapper">
				<div v-if="appearance === 'secondary' && availableForPreOrder" :class="$style.preOrderText">
					Available for pre-order
				</div>
				<div :class="$style.mainContent">
					<BlockAffirm
						v-if="affirm && currentPrice"
						page-type="landing"
						:price="currentPrice"
						:class="$style.affirm"
						@update="affirmUpdated"
					/>
					<div :class="$style.oneTime">
						<span v-if="listPriceString">
							<span class="u-visuallyhidden">regular price</span>
							<span :class="$style.listPriceWrapper">
								<span :class="$style.listPrice">{{ listPriceString }}</span>
							</span>
							<span class="u-visuallyhidden">sale price</span>
						</span>
						{{ currentPriceString }}</div
					>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import { mapGetters } from 'vuex';
import BlockAffirm from '@components/block-affirm';

const priceUSD = (dollars, currencySymbol) => {
	return `${currencySymbol}${dollars || 0}`;
};

export default {
	components: {
		BlockAffirm,
	},

	props: {
		currentPrice: {
			type: Number,
			default: undefined,
		},

		listPrice: {
			type: Number,
			default: 0,
		},

		bottomOutside: {
			type: Boolean,
			default: false,
		},

		affirm: {
			type: Boolean,
			default: true,
		},

		appearance: {
			type: String,
			default: '',
			validator: (v) => ['', 'secondary'].includes(v),
		},

		affirmTextColor: {
			type: String,
			default: '',
			validator: (v) => ['', 'primary'].includes(v),
		},

		availableForPreOrder: {
			type: Boolean,
			default: false,
		},
	},

	computed: {
		...mapGetters(['currencySymbol']),

		currentPriceString() {
			const { currentPrice } = this;
			if (currentPrice === undefined || currentPrice === 0)  return '\xA0';
			return priceUSD(currentPrice, this.currencySymbol);
		},

		listPriceString() {
			const { listPrice, currentPrice } = this;
			if (!listPrice || (parseFloat(listPrice) <=  parseFloat(currentPrice))) return '';
			return priceUSD(listPrice, this.currencySymbol);
		},
	},

	methods: {
		affirmUpdated(el) {
			const bottom = el.querySelector('.affirm-pmt-bottom');
			if (bottom) {
				bottom.appendChild(document.createTextNode('. '));
				const trigger = el.querySelector('.affirm-modal-trigger');
				if (trigger) {
					bottom.appendChild(trigger);
				}

				const logo = bottom.querySelector('.__affirm-logo');
				if (logo) {
					logo.setAttribute('aria-hidden', 'true');
					logo.insertAdjacentHTML('afterend', '<span class="screen-reader-only">Affirm</span>');
				}
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.row {
	position: relative;
	display: flex;
	white-space: nowrap;

	.affirm {
		padding-bottom: 2rem;
	}

	:global(.affirm-pmt-block),
	.oneTime,
	.preOrderText {
		@include use-text-style('heading-200');

		display: block;
		font-weight: 300;
	}

	:global(.affirm-pmt-block) {
		margin-bottom: size('xxs');
	}

	:global(.affirm-ala-month) {
		&::after {
			content: '*\00a0|\00a0';
		}
	}

	:global(.affirm-pmt-bottom) {
		position: absolute;
		bottom: 0;
		left: 0;
		width: 100%;
		font-size: 1.2rem;
		color: color('primary-200');

		&::before {
			content: '*';
		}
	}

	:global(.affirm-modal-trigger) {
		color: inherit;
	}

	:global(.affirm-learn-more) {
		display: inline-block;
		font-weight: 700;
		text-transform: lowercase;

		&::first-letter {
			text-transform: uppercase;
		}
	}
}

.rowsecondary {
	composes: row;
	display: flex;
	color: color('primary');

	.contentWrapper {
		display: flex;
		flex-direction: column;
		align-items: center;
		justify-content: center;
		height: 5.6rem;
	}

	.mainContent {
		display: flex;
	}

	@include above('medium') {
		&.hasListPrice .mainContent {
			flex-direction: column;
		}
	}

	.affirm {
		padding-bottom: 2rem;
	}

	:global(.affirm-pmt-block),
	.oneTime,
	.preOrderText {
		@include use-text-style('heading-100');
	}

	&.hasAffirm .oneTime {
		&::before {
			content: '\00a0|\00a0';
		}
	}

	&.hasListPrice .oneTime {
		@include above('medium') {
			&::before {
				display: none;
			}
		}
	}

	:global(.affirm-ala-month) {
		&::after {
			content: '*';
		}
	}

	:global(.affirm-pmt-bottom) {
		@include use-text-style('type-100');

		left: 50%;
		margin: auto;
		font-weight: 300;
		line-height: 1.9;
		white-space: normal;
		transform: translateX(-50%);

		@include above('medium') {
			@include use-text-style('type-200');

			max-width: 18.3rem;
		}
	}

	:global(.affirm-modal-trigger) {
		font-weight: 400;
	}
}

.productPrice.bottomOutside .row {
	position: static;

	.affirm {
		padding-bottom: 0;
	}

	:global(.affirm-pmt-block) {
		margin-bottom: 0;
	}
}

.productPrice.bottomOutside .rowsecondary {
	padding-bottom: 2rem;

	@include above('medium') {
		padding-bottom: 2.2rem;
	}
}

.listPriceWrapper {
	color: color('red');
	text-decoration: line-through;
}

.listPrice {
	color: color('primary-200');
}

.productPrice .row.primaryAffirmTextColor {
	.affirm :global(.affirm-pmt-bottom) {
		color: color('primary');
	}

	.affirm :global(.affirm-learn-more) {
		color: color('primary');
	}
}
</style>
